<script lang="ts">
  import Item from '$lib/components/Items/Item.svelte';
  import { createEventDispatcher } from 'svelte';
  import { PUBLIC_API_URL } from '$env/static/public';

  export let file: File,
    id: number | undefined = undefined,
    download: boolean = false;

  const dispatch = createEventDispatcher();

  let src: any = id && file.type.includes('image') || file.type.includes('video') ? `${PUBLIC_API_URL}/attachment/${id}` : '';

  function handleRemove() {
    if (id) {
      dispatch('remove', { id, file });
    } else {
      dispatch('remove', file);
    }
  }

  $: if (!id) {
    if (file.type.includes('image') || file.type.includes('video')) {
      const reader = new FileReader();

      reader.onload = event => {
        if (file.type.includes('image')) {
          src = event?.target?.result;
        }

        // if (file.type.includes('video')) {
        //   const buffer = e.target.result,
        //     videoBlob = new Blob([new Uint8Array(buffer)], { type: 'video/mp4' }),
        //     url = window.URL.createObjectURL(videoBlob);
        //
        //   src = url;
        // }
      };

      if (file.type.includes('image')) {
        reader.readAsDataURL(file);
      }

      // if (file.type.includes('video')) {
      //   reader.readAsArrayBuffer(file);
      // }
    } else {
      src = '';
    }
  }

  console.log(src);
</script>

<Item class="flex-wrap">
    <section class="flex flex-wrap items-center gap-6">
        {#if src}
            {#if file.type.includes('video')}
                <video class="{download ? 'w-64 h-36' : 'w-64 h-36'} aspect-video object-cover rounded" controls>
                    <source {src}>
                    <track kind="captions" {src}>
                </video>
            {:else}
                <img {src} alt="" class="{download ? 'w-64 h-36' : 'w-16 h-9'} aspect-video object-cover rounded">
            {/if}
        {/if}
        <section>
            <p>
                {file.name}
            </p>
            <p class="text-neutral-400">{(file.size / 1024).toFixed(2)} КБ</p>
        </section>
    </section>
    <section>
        {#if download}
            <a href="{PUBLIC_API_URL}/attachment/{id}" download={file.name}
               class="text-lg text-blue-700 font-bold font-serif hover:underline decoration-blue-700">Скачать</a>
        {:else}
            <button type="button" on:click={handleRemove}>X</button>
        {/if}
    </section>
</Item>